var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  default: () => index_default
});
module.exports = __toCommonJS(index_exports);
var import_node_fs = __toESM(require("fs"), 1);
var import_node_path = require("path");
var import_magic_string = __toESM(require("magic-string"), 1);
var import_node_process = __toESM(require("process"), 1);
function VitePluginAutoOptimizeDepsInclude(option = {}) {
  return {
    name: "update-optimizeDeps-include",
    apply: "serve",
    enforce: "pre",
    configureServer: (server) => {
      const originalWrite = import_node_process.default.stdout.write;
      const viteConfigPath = server.config.configFile || (0, import_node_path.resolve)(import_node_process.default.cwd(), "vite.config.ts");
      import_node_process.default.stdout.write = function(...args) {
        const r = originalWrite.apply(import_node_process.default.stdout, args);
        const str = args.at(0).toString().replace(/\x1B\[[0-9;]*m/g, "");
        handle(str);
        return r;
      };
      function handle(dependenciesStr) {
        const configContent = import_node_fs.default.readFileSync(viteConfigPath, "utf-8");
        const str = new import_magic_string.default(configContent);
        const start = findStartIndexAndIndent(configContent);
        const startIndex = start.index;
        const indent = start.indent;
        if (!startIndex) return;
        const data = dependenciesStr.match(option.regex || /new dependencies optimized:(.*)\n/);
        if (data) {
          const list = data[1].split(",").map((i) => i.trim());
          const current = findCurrentList(configContent.slice(startIndex));
          const currentList = current.list;
          const endIndex = current.index + startIndex;
          const newList = [.../* @__PURE__ */ new Set([...currentList, ...list])].filter(Boolean).sort((a, b) => a.length - b.length);
          const newStr = newList.reduce((pre, cur) => {
            return `${pre}${" ".repeat(indent + 2)}'${cur}',
`;
          }, "\n");
          str.update(startIndex, endIndex, newStr + " ".repeat(indent));
          server.watcher.unwatch(viteConfigPath);
          const { atime, mtime } = import_node_fs.default.statSync(viteConfigPath);
          import_node_fs.default.writeFileSync(viteConfigPath, str.toString());
          import_node_fs.default.utimesSync(viteConfigPath, atime, mtime);
          server.watcher.add(viteConfigPath);
        }
      }
      function findStartIndexAndIndent(parentStr) {
        const match = parentStr.match(/optimizeDeps:[\s\S]*?include:\s?\[/);
        if (!match) {
          return {
            index: 0,
            indent: 0
          };
        }
        return {
          index: match.index + match[0].length,
          indent: match[0].split("\n").pop().match(/^\s*/)[0].length
        };
      }
      function findCurrentList(parentStr) {
        for (let i = 0; i < parentStr.length; i++) {
          if (parentStr[i] === "]") {
            const str = parentStr.slice(0, i);
            return {
              list: str.split(",").map((i2) => i2.replace(/['"]/g, "").trim()),
              index: i
            };
          }
        }
        return {
          list: [],
          index: 0
        };
      }
    }
  };
}
var index_default = VitePluginAutoOptimizeDepsInclude;
